parameters choice
private fami_rec, memb_rec

* begin
    select MEMBERS
    memb_rec = recno()
    select FAMILIES
    fami_rec = recno()
    do case
    case choice = 1
        AddressBook()
    case choice = 2
        AnniSched()
    case choice = 3
        BdayCale()
    case choice = 4
        BdaySched()
    case choice = 5
        prntenv()
    case choice = 6
        PhoneBook()
    endcase
    select MEMBERS
    goto memb_rec
    select FAMILIES
    goto fami_rec
return

*---------------------------------PHONEBOOK------------------------------------*

function PhoneBook

private pagenum, memstring

* begin
    prompt(-1, -1, 'Printing.  Press <Esc> to abort...', .f.)
    select FAMILIES
    go top
    set device to print
    pagenum = 0
    @ 1,0 say _10cpi
    do while (.not. eof()) .and. (.not. nextkey() = 27)
        pagenum = pagenum + 1
        @ 2,0 say center('Phone Book', 80)
        @ 3,0 say center('As of ' + dtoc(date()), 80)
        @ 3,71 say 'Page ' + str(pagenum, 3, 0)
        @ 5,0 say '  Last Name         Phone                            Members'
        @ 5,0 say '_______________ _____________ __________________________________________________'
        @ 5,0 say '  Last Name         Phone                            Members'
        @ 5,0 say '_______________ _____________ __________________________________________________'
        do while (.not. eof()) .and. (prow() < 56) .and. (.not. nextkey() = 27)
            @ prow()+2,0 say NAME + ' ' + PHONE
            select MEMBERS
            seek FAMILIES->UNIQUE
            memstring = ''
            do while (UNIQUE == FAMILIES->UNIQUE)
                memstring = memstring + trim(NAME) + ', '
                skip
            enddo
            memstring = left(memstring, 48)
            memstring = left(memstring, rat(',', memstring) - 1)
            @ prow(),30 say memstring
            seek FAMILIES->UNIQUE
            memstring = ''
            do while (UNIQUE == FAMILIES->UNIQUE) .and. (.not. nextkey() = 27)
                if .not. empty(unpicture(PHONE, '(999)999-9999'))
                    @ prow()+1,3 say NAME + ' ' + PHONE
                endif
                skip
            enddo
            select FAMILIES
            skip
        enddo
    enddo
    do while (nextkey() = 27)
        inkey(0)
    enddo
    eject
    set device to screen
    vpopscrn()
return ''

*---------------------------------ADDRESSBOOK----------------------------------*

function AddressBook

private fletter, one_letter

* begin
    prompt(-1, -1, 'Print last names beginning with X (leave blank for all names)', .f.)
    fletter = ' '
    @ row(), col()-29 get fletter picture '!'
    vsetcursor(.t.)
    read
    vsetcursor(.f.)
    vpopscrn()
    one_letter = (fletter >= 'A' .and. fletter <='Z')
    prompt(-1, -1, 'Printing.  Press <Esc> to abort...', .f.)
    select FAMILIES
    if one_letter
        seek fletter
    else
        go top
    endif
    set device to print
    set margin to 5
    @ 1,0 say _12cpi
    do while (.not. eof()) .and. (.not. nextkey() = 27)
        if .not. one_letter
            fletter = left(NAME, 1)
        endif
        do while (.not. eof()) .and. (.not. nextkey() = 27) .and. (left(NAME,1) = fletter)
            @ 2,0 say center('Address Book', 86)
            @ 3,0 say center('As of ' + dtoc(date()), 86)
            @ 4,42 say '"'+fletter+'"'
            @ prow()+2,0 say replicate('-', 86)
            fcount = 0
            do while (.not. eof()) .and. (.not. nextkey() = 27) .and. (left(NAME,1) = fletter) .and. (fcount < 7)
                fcount = fcount + 1
                @ prow()+2,0 say _boldon + NAME + _boldoff
                @ prow(),0 say ' '
                select MEMBERS
                seek FAMILIES->UNIQUE
                PrintMemb()
                @ prow()+1,0 say ADDRESS1
                PrintMemb()
                if .not. empty(ADDRESS2)
                    @ prow()+1,0 say ADDRESS2
                    PrintMemb()
                endif
                @ prow()+1,0 say trim(CITY) + if(empty(CITY), '', ', ') + STATE + ' ' + left(ZIP, if(empty(right(ZIP,4)), 5, 10))
                PrintMemb()
                @ prow()+1,0 say PHONE
                PrintMemb()
                if empty(ADDRESS2)
                    @ prow()+1,0 say ''
                    PrintMemb()
                endif
                @ prow()+2,0 say replicate('-', 86)
                skip
            enddo
            do while (fcount < 7)
                fcount = fcount + 1
                @ prow()+8,0 say replicate('-', 86)
            enddo
        enddo
        if one_letter
            exit
        endif
    enddo
    do while (nextkey() = 27)
        inkey(0)
    enddo
    eject
    set margin to 0
    set device to screen
    vpopscrn()
return ''

function PrintMemb

* begin
    select MEMBERS
    if UNIQUE == FAMILIES->UNIQUE
        @ prow(),40 say pad( trim(NAME) + ' ' + if(empty(MINIT), '', MINIT + '. '), 15) + PHONE + ' ' + transform(BIRTHDAY, '@D') + ' ' + transform(ANNIVERS, '@D')
        skip
    endif
    select FAMILIES
return ''

*---------------------------------BDAYSCHED------------------------------------*

function BdaySched

private pagenum

* begin
    prompt(-1, -1, 'Printing.  Press <Esc> to abort...', .f.)
    select FAMILIES
    set order to 2
    select MEMBERS
    set order to 2
    set softseek on
    seek '0101'
    set softseek off
    set device to print
    pagenum = 0
    @ 1,0 say _10cpi
    do while (.not. eof()) .and. (.not. nextkey() = 27)
        pagenum = pagenum + 1
        @ 2,0 say center('Birthday Schedule', 60)
        @ 3,0 say center('As of ' + dtoc(date()), 60)
        @ 3,52 say 'Page ' + str(pagenum, 3, 0)
        @ 5,0 say '      Birthday                   Name               Will Be'
        @ 5,0 say '____________________ ______________________________ _______'
        @ 5,0 say '      Birthday                   Name               Will Be'
        @ 5,0 say '____________________ ______________________________ _______'
        do while (.not. eof()) .and. (.not. nextkey() = 27) .and. (prow() < 56)
            select FAMILIES
            seek MEMBERS->UNIQUE
            select MEMBERS
            @ prow()+1,0 say pad(cmonth(BIRTHDAY) + ' ' + ltrim(str(day(BIRTHDAY))), 20) + ' ' + pad(trim(NAME) + ' ' + if(empty(MINIT), '', MINIT + '. ') + trim(FAMILIES->NAME), 30) + ' ' + str( year(date()) - year(BIRTHDAY), 7, 0 )
            skip
        enddo
    enddo
    do while (nextkey() = 27)
        inkey(0)
    enddo
    eject
    set device to screen
    vpopscrn()
    set order to 1
    select FAMILIES
    set order to 1
return ''

*---------------------------------ANNISCHED------------------------------------*

function AnniSched

private pagenum

* begin
    prompt(-1, -1, 'Printing.  Press <Esc> to abort...', .f.)
    select FAMILIES
    set order to 2
    select MEMBERS
    set order to 3
    set softseek on
    seek '0101'
    set softseek off
    set device to print
    pagenum = 0
    @ 1,0 say _10cpi
    do while (.not. eof()) .and. (.not. nextkey() = 27)
        pagenum = pagenum + 1
        @ 2,0 say center('Anniversary Schedule', 60)
        @ 3,0 say center('As of ' + dtoc(date()), 60)
        @ 3,52 say 'Page ' + str(pagenum, 3, 0)
        @ 5,0 say '     Anniversary                 Name               Married'
        @ 5,0 say '____________________ ______________________________ _______'
        @ 5,0 say '     Anniversary                 Name               Married'
        @ 5,0 say '____________________ ______________________________ _______'
        do while (.not. eof()) .and. (.not. nextkey() = 27) .and. (prow() < 56)
            select FAMILIES
            seek MEMBERS->UNIQUE
            select MEMBERS
            @ prow()+1,0 say pad(cmonth(ANNIVERS) + ' ' + ltrim(str(day(ANNIVERS))), 20) + ' ' + pad(trim(NAME) + ' ' + if(empty(MINIT), '', MINIT + '. ') + trim(FAMILIES->NAME), 30) + ' ' + str( year(date()) - year(ANNIVERS), 7, 0 )
            skip
        enddo
    enddo
    do while (nextkey() = 27)
        inkey(0)
    enddo
    eject
    set device to screen
    vpopscrn()
    set order to 1
    select FAMILIES
    set order to 1
return ''

*---------------------------------BDAYCALE-------------------------------------*

function BdayCale

private num, month, week, day, slot, date

declare slots1[7]
declare slots2[7]
declare slots3[7]
declare slots4[7]
declare slots5[7]
declare slots6[7]
declare slots7[7]

begin sequence
    prompt(-1, -1, 'Printing.  Press <Esc> to abort...', .f.)
    year = year(date())
    select FAMILIES
    set order to 2
    select MEMBERS
    set order to 2
    go top
    set device to print
    @ 1,0 say _17cpi

    for month = 1 to 12
        date = ctod(str(month, 2, 0) + '/01/' + str(year, 4, 0))

        * print header
        @ 1,0 say center('Birthday and Anniversary Schedule', 134)
        @ 2,0 say center(cmonth(date) + ' ' + str(year(date), 4, 0), 134)
        @ 4,0 say 'ͻ'
        @ 5,0 say '      Sunday            Monday            Tuesday          Wednesday         Thursday           Friday           Saturday     '

        * adjust date to day before first day on calendar
        do while (dow(date) > 1)
            date = date - 1
        enddo
        date = date - 1

        for week = 1 to 6
            @ prow()+1,0 say 'Ķ'
            @ prow()+1,0 say ''
            for day = 1 to 7
                num = chr(day + 48)
                date = date + 1
                @ prow(),pcol() say if(month(date) = month, str(day(date), 2, 0), '  ') + space(16) + if(day = 7, '', '')
                if month(date) = month
                    seek right(dtos(date), 4)
                    slot = 0
                    do while (right(dtos(BIRTHDAY), 4) = right(dtos(date), 4)) .and. (slot < 7)
                        slot = slot + 1
                        select FAMILIES
                        seek MEMBERS->UNIQUE
                        select MEMBERS
                        slots&num[slot] = pad('+' + trim(left(NAME, 7)) + ' ' + FAMILIES->NAME, 18) + if(day = 7, '', '')
                        skip
                    enddo
                    set order to 3
                    seek right(dtos(date), 4)
                    do while (right(dtos(ANNIVERS), 4) = right(dtos(date), 4)) .and. (slot < 7)
                        slot = slot + 1
                        select FAMILIES
                        seek MEMBERS->UNIQUE
                        select MEMBERS
                        slots&num[slot] = pad('*' + trim(left(NAME, 7)) + ' ' + FAMILIES->NAME, 18) + if(day = 7, '', '')
                        skip
                    enddo
                    set order to 2
                    do while (slot < 7)
                        slot = slot + 1
                        slots&num[slot] = space(18) + if(day = 7, '', '')
                    enddo
                else
                    for slot = 1 to 7
                        slots&num[slot] = space(18) + if(day = 7, '', '')
                    next slot
                endif
                if nextkey() = 27
                    break
                endif
            next day
            for slot = 1 to 7
                @ prow()+1,0 say ''
                for day = 1 to 7
                    num = chr(day + 48)
                    @ prow(), pcol() say slots&num[slot]
                next day
            next slot
        next week
        @ prow()+1,0 say 'ͼ'
        @ prow()+1,0 say '+ is a birthday, * is an anniversary'
    next month
end sequence
    do while (nextkey() = 27)
        inkey(0)
    enddo
    eject
    set device to screen
    select MEMBERS
    set order to 1
    select FAMILIES
    set order to 1
    vpopscrn()
return ''

*----------------------------------PRNTENV-------------------------------------*

function prntenv
parameters callprog, linenum, inputvar

private addressee

* begin
    if alias() == 'FAMILIES'
        addressee = pad(NAME, 35)
        prompt(-1, -1, 'Enter Addressee: ' + space(35), .f.)
        @ row(), col()-35 get addressee
        vsetcursor(.t.)
        read
        vsetcursor(.f.)
        vpopscrn()
    else
        addressee = trim(NAME) + ' ' + trim(MINIT) + if(empty(MINIT), '', '. ') + trim(FAMILIES->NAME)
    endif
    set device to print
    @ 1,2 say 'John T. Opincar, Jr.'
    @ 2,2 say '4305 Duval #213'
    @ 3,2 say 'Austin, Tx 78751'
    @ 13,20 say addressee
    @ prow()+1,20 say FAMILIES->ADDRESS1
    if .not. empty(FAMILIES->ADDRESS2)
        @ prow()+1,20 say FAMILIES->ADDRESS2
    endif
    @ prow()+1,20 say trim(FAMILIES->CITY) + if(empty(FAMILIES->CITY), '', ', ') + FAMILIES->STATE + ' ' + left(FAMILIES->ZIP, if(empty(right(FAMILIES->ZIP,4)), 5, 10))
    eject
    set device to screen
return ''

