private oldctrl

* begin
    select MEMBERS
    if findmemb > 0
        goto findmemb
        findmemb = 0
    else
        seek FAMILIES->UNIQUE
    endif
    vsetcolor(_c_memb_st, _c_memb_en, _c_memb_un)
    if passclick
        passclick = .f.
        keyinsert(-131)
    endif
    mdefctrl(4, 1, 12, 29, 251)
    menuedit(4, 33, 12, '', mfields, mpics, 'memb_monitor', 'UNIQUE == FAMILIES->UNIQUE', FAMILIES->UNIQUE)
    mrestctrl(4, 1, 12, 29, famictrl)
    mdefctrl(4, 33, 12, 78, 252)
    vsetcolor(_c_fami_st, _c_fami_en, _c_fami_un)
    select FAMILIES
return

*--------------------------------MEMB_MONITOR----------------------------------*

function memb_Monitor

parameters Mode, fld_ptr

private return_val, lastkey, choice

* begin
    return_val = 1
    if mode = 1 .or. mode = 2
        tone(100,1)
    elseif mode = 3
        if appending
            appending = .f.
            keyinsert(-23)
        else
            if prompt(7, -1, 'There are no members for this family.  You can...', .t., 'Insert', 'Abort') = 'I'
                keyinsert(-23)
            else
                keyinsert(-33)
            endif
        endif
        lastkey = inkey(0)
        mode = 4
    endif
    if mode = 4
        lastkey = lastkey()
        if ((keyconv(lastkey) >= -50) .and. (keyconv(lastkey) <= -16)) .or.;
           ((lastkey = 387) .and. (mgetbutton() == 'L ') .and. (mgetctrl() = 255))
            choice = showmenu()
            if (choice = 20)
                BlakDial()
                vpopscrn()
            elseif (choice = 30)
                MembDel(@return_val)
                vpopscrn()
            elseif (choice = 40)
                MembEd(@return_val)
                vpopscrn()
            elseif (choice = 60)
                MembAdd()
                vpopscrn()
                return_val = 2
            elseif (choice = 70)
                MembFind(@return_val)
                vpopscrn()
            else
                passchoice = choice
                return_val = 0
            endif
        elseif (lastkey = 387) .and. (mgetbutton() == 'L ') .and. (mgetctrl() < 255)
            if mgetctrl() = 251     &&Family
                return_val = 0
                keyinsert(-131)
            elseif mgetctrl() = 253 &&Address
                return_val = 0
                keyinsert(-30)
                passclick = .t.
            elseif mgetctrl() = 254 &&Notes
                return_val = 0
                keyinsert(-49)
            elseif mgetctrl() = 240
                keyinsert(-132)
            elseif mgetctrl() = 239
                keyinsert(-73)
            elseif mgetctrl() = 238
                keyinsert(-72)
            elseif mgetctrl() = 237
                keyinsert(-80)
            elseif mgetctrl() = 236
                keyinsert(-81)
            elseif mgetctrl() = 235
                keyinsert(-118)
            endif
        elseif (lastkey = 13) .or. (lastkey = 25) .or. ((lastkey >= 32) .and. (lastkey <= 254))
            if (lastkey <> 13)
                keyboard chr(lastkey)
            endif
            FamiRead(mfields[fld_ptr], mpics[fld_ptr], @return_val)
        elseif lastkey = 27
            return_val = 0
        endif
    endif
return return_val

*----------------------------------MEMBFIND------------------------------------*

function membFind
parameters ret_val

private namem, old_rec

* begin
    old_rec = recno()
    namem = space(12)
    prompt(17, -1, "Enter all or part of member's name: " + namem, .f.)
    @ row(), col()-12 get namem
    vsetcursor(.t.)
    read
    vsetcursor(.f.)
    if .not. empty(namem)
        seek FAMILIES->UNIQUE + upper(trim(namem))
        if .not. found()
            tone(100, 1)
            goto old_rec
        else
            ret_val = 2
        endif
    endif
    vpopscrn()
return ''

*----------------------------------MEMBADD-------------------------------------*

function membAdd

* begin
    append blank
    replace UNIQUE with FAMILIES->UNIQUE
    keyinsert(-18)
return ''

*----------------------------------MEMBDEL-------------------------------------*

function membdel
parameters ret_val

private row

* begin
    row = row()
    vfillattr(row, 33, row, 78, vsetenha())
    if prompt(-1, -1, 'Are you sure that you want to permanently delete this family member? (Y/N)', .t., 'Yes', 'No') = 'Y'
        ret_val = 2
        DELETE
        skip
    endif
    vfillattr(row, 33, row, 78, vsetstan())
return ''

*-----------------------------------MEMBED-------------------------------------*

function membEd
parameters ret_val

private old_key, row

* begin
    row = row()
    old_key = get_key()
    @ row,33 get NAME picture mpics[1]
    @ row, col() say ''
    @ row, col() get MINIT picture mpics[2]
    @ row, col() say ''
    @ row, col() get PHONE picture mpics[3]
    @ row, col() say ''
    @ row, col() get BIRTHDAY picture '@D'
    @ row, col() say ''
    @ row, col() get ANNIVERS picture '@D'
    helpbar(edesc, ekeys)
    vsetcursor(.t.)
    mpushstate()
    msetcursor(.t.)
    msetbutton(.t.)
    set key 387 to findclick
    read
    set key 387 to
    mpopstate()
    vsetcursor(.f.)
    vpopscrn()
    if (.not. old_key == get_key())
        ret_val = 2
    endif
    vfillattr(row, 33, row, 78, vsetstan())
return ''
